/***************************************************************************
 *   Copyright (C) 2004 by Michael Moritz                                  *
 *   mimo@restoel.net                                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef __ACTION_H
#define __ACTION_H

#include <string>

//@brief class for returning result
class Action
{
public:
	typedef enum {
		dunno,
		defer
	}ActionType;
	
	Action(ActionType t) {
		std::string act;
		switch(t) {
			case defer:
				act = "defer_if_permit Service is unavailable";
				break;
			case dunno:
			default:
				act = "dunno";
				break;
		}
		if(g_getCfg().isVerbose())
			syslog(LOG_DEBUG,"action=%s",act.c_str());
		std::cout << "action=" << act << "\n" << std::endl;
	}
};
#endif
