<? 

// gps database maintenance web interface
// (C)2004 Michael Moritz mimo/at/restoel.net
// Project homepage: http://mimo.gn.apc.org/gps


define('VERBOSE',0);
define('CFGFILE',"/usr/local/etc/gps.conf");
define('DEFLIMIT',20);
$tables = array(
	"Triplets"=>array(
		"ops"=>array(
			"search"=>array(
				"sender"=>array("name"=>"Sender's e-mail address"),
				"recipient"=>array("name"=>"Recipient's e-mail address"),
				"client_address"=>array("name"=>"Server's IP address"))
		),
		"name"=>"Greylisting database"),
	"network"=>array(
		"ops"=>array(
			"search"=>array(
				"address"=>array("name"=>"Server's IP address"),
				"comment"=>array("name"=>"Comment")),
			"insert"=>array(
				"address"=>array("hint"=>"Format: 192.168.0<b>.</b>"),
				"comment"=>array("name"=>"Comment")),
		),
		"tableops"=>array(
			"delete"=>array("name"=>"delete")
		),
		"name"=>"Whitelisted networks"),
	"sender"=>array("ops"=>array(
			"search"=>array(
				"address"=>array("name"=>"Sender's e-mail address"),
				"comment"=>array("name"=>"Comment")),
			"insert"=>array("address"=>array(),"comment"=>array()),
		),
		"tableops"=>array(
			"delete"=>array("name"=>"delete")
		),
		"name"=>"Whitelisted senders"),
	"recipient"=>array("ops"=>array(
			"search"=>array(
				"address"=>array("name"=>"Recipient's e-mail address"),
				"comment"=>array("name"=>"Comment")),
			"insert"=>array("address"=>array(),"comment"=>array()),
		),
		"tableops"=>array(
			"delete"=>array("name"=>"delete")
		),
		"name"=>"Whitelisted recipients")
	);
$operations = array(
	"search"=>array("name"=>"search","type"=>"text","help"=>"You can use wildecards, e.g. 'someone%'"),
	"insert"=>array("name"=>"insert","type"=>"text")
	);
function dbg($arg,$label="")
{
	print("<pre>".$label.($label!=""?": ":""));
//	if(is_array($arg))
		print_r($arg);
//	else
//		print($arg);
	print("\n</pre>\n");
}
function fatal($arg,$label)
{
	print("<div style='color:RED;'>FATAL ");
	dbg($arg,$label);
	print("</div>");
	die;
}
function readConfigFile()
{
	$cfg = array();
	$handle = fopen(CFGFILE, "r");
	while (!feof($handle)) {
		$cfgline = fscanf($handle, "%s\n");
		if ($cfgline) {
			if(strpos($cfgline[0],"#") === 0) //skip comment
				continue;
			$line_arr = explode("=",$cfgline[0],2);
			//if(VERBOSE)
			//	dbg($line_arr);
			$cfg[(string)$line_arr[0]] = $line_arr[1];
		}
	}
	fclose($handle);
	return $cfg;
}
function pr_dbstatus($status,$cfg,$ok=true) 
{
	print("<div><b>Database Status: </b><span style='color: "
		.($ok?"GREEN":"RED")."';>".$status." to database on host <i>".$cfg[db_host]."</i></span></div>");
}

function formutil($fields) 
{
	$out = "";
	foreach($fields as $key=>$val) {
		if(!is_array($val)) {
			$out .= "<input type='hidden' name='$key' value='$val'>\n";
		} else {
			if(is_string($key)) {
					$out .= "<input type='$key' ";
					foreach($val as $k=>$v)
						$out .= "$k='$v' ";
					$out .= ">\n";
			} else {
					$out .= implode("\n",$val)."\n";
			}
		}
	}
	return $out;
}
function table_menu($line,$rows)
{
	global $tables,$operations;
	$out .= "<tr>\n";
	$out .= "<td>\n<b>";
	$out .= $tables[$line][name];
	$out .= "</b><br><span style='font-size:smaller;'>(".$rows." records)</span>";
	$out .= "</td>";
	$out .= "<td>";
	$out .= "<table bgcolor=#DDDDDD width=100%>";
	$opcount = 0;
	foreach($operations as $opname=>$op) {
//		$out .= "<tr><td>";
//		$out .= "<table bgcolor=#DDDDDD>";
		if(in_array($opname,array_keys($tables[$line][ops]))) {
			$opcount++;
			if($op[type] == 'text') {
				if($opcount == 1) {
					$out .= "<tr class='sm'><td>&nbsp;</td>";
					foreach($tables[$line][ops][$opname] as $opv)
						$out .= "<td>".$opv['name']."</td>";
					$out .= "</tr>\n";
				}
				$out .= "<tr>\n";
				$out .= formutil(array(
					array("<form>"),
					array("<td>"),
					'submit'=>array('name'=>$op[name],'value'=>$op[name]),
					'table'=>$line,
					'title'=>$tables[$line][name],
					'mode'=>$opname,
					array("</td>")
					));
				foreach($tables[$line][ops][$opname] as $opkey=>$opv)
					$out .= formutil(array(
						array("<td>"),
						'text'=>array('name'=>"value[".$opkey."]"),
						($opv[hint]?
							array("<div class='hint'>",$opv[hint],"</div>")
							:array("")),
						array("</td>")
						));
				$out .= "</tr>\n";
				$out .= "</form>\n";
			}
//			if($op[help])
//				$out .= "</td></tr><tr align='center'><td style='font-size:smaller;' colspan ='10'>".$op[help]."\n";
		} 
		//$out .= "</table>";
		//$out .= "</td></tr>";
	}
	$out .= "</table>\n";
	$out .= "</td>\n";
	$out .= "</tr>\n";
	return $out;
}
function show_tables($link,$args)
{
	/* Performing SQL query */
	$query = "SHOW TABLE STATUS";
	$result = mysql_query($query) or fatal("Query failed : " . mysql_error(),"DB");
	$out = "<table border='0' bgcolor=#EEEEEE>\n";
	$out .= "<tr><th bgcolor=#DDDDDD>Table</th><th bgcolor=#DDDDDD colspan='10'>Operations</th></tr>";
	while ($line = mysql_fetch_array($result, MYSQL_ASSOC)) {
		$out .= table_menu($line['Name'],$line['Rows']);
	}
	$out .= "</table>\n";
	return $out;
}
function search($link,$args)
{	
	global $tables;
	$title = $args['title'];
	$table = $args['table'];
	$value = ($args['value']?$args['value']:"%");
	$lstart = (int)($args['lstart']?$args['lstart']:0);
	$lend = (int)($args['lend']?$args['lend']:DEFLIMIT);
	if(!$table)
		fatal("no table given","Internal");
	$where = "";
	foreach($tables[$table][ops][search] as $wa=>$wa1) {
		if($value[$wa]) {
			$where .= ($where!=""?" AND ":"");
			$where .= "`".$wa."` LIKE '".$value[$wa]."'";
		}
	}
	$url = "title=".urlencode($title)."&table=".urlencode($table);
	$url .= "&mode=search";
	foreach($value as $key=>$va)
		$url .= "&value[$key]=".urlencode($va);
	$query = "SELECT * FROM ".$table.($where!=""?" WHERE ( ".$where." ) ":"")." LIMIT ".$lstart.",".$lend;
	if(VERBOSE)
		dbg($query,"query");
	$result = mysql_query($query) or fatal("Query failed : " . mysql_error(),"DB");
	$out .= "<p>Showing ".$lstart." - ".($lstart+$lend)."\n";
	$out .= ($lstart>0?"<a href='?".$url."&lstart=".($lstart-DEFLIMIT)."&lend=".$lend."'>Previous</a>&nbsp;":"");
	$out .= "<a href='?".$url."&lstart=".($lstart+DEFLIMIT)."&lend=".($lend)."'>Next</a>&nbsp;</p>";
	$out .= "<table border='0' bgcolor=#EEEEEE>\n";
	$out .= "<tr>\n";
	$num_fields = mysql_num_fields($result);
	for($i=0;$i<$num_fields;$i++) {
		$fieldname = mysql_field_name($result, $i);
		$out .= "<th bgcolor=#DDDDDD>"
			.$fieldname
			."</th>";
	}
	if(count($tables[$table]["tableops"]))
		$out .= "<th bgcolor=#DDDDDD colspan='".count($tables[$table]["tableops"])."'>"
			."Operations</th>";
	$out .= "</tr>\n";
	while ($line = mysql_fetch_array($result, MYSQL_ASSOC)) {
		unset($where);
		$out .= "\t<tr>\n";
		foreach ($line as $fn=>$col_value) {
			$out .= "\t\t<td>";
			if($fn == 'uts') 
				$out .= date('y-m-d H:i:s D',$col_value);
			else
				$out .= $col_value;
			$out .= "</td>\n";
			$where[] = "`$fn`='$col_value'";
		}
		//dbg($where);
		if($tables[$table]["tableops"] && count($where)) {
			$returnurl = $url."&lstart=".$lstart."&lend=".$lend;
			foreach($tables[$table]["tableops"] as $k=>$op) {
				$out .= formutil(array(
					array('<form>','<td>'),
					'returnurl'=>$returnurl,
					'table'=>$table,
					'mode'=>"delete",
					'where'=>urlencode(implode(" AND ",$where)),
					'submit'=>array('name'=>$op[name],'value'=>$k),
					array('</form>','</td>','<td>')
					));
			}
		}
		$out .= "\t</tr>\n";
	}
	$out .= "</table>\n";
	return $out;
}
function quicksql($link,$optext,$table,$where,$sometext,$othertext)
{
	$out = "";
	if(!$table)
		fatal("no table given","Internal");
	if(VERBOSE) {
		if($optext != "DELETE FROM ") {
			$out .= "no verbose for ".$optext;
			break;
		}
		$query = "SELECT * FROM ".$table." WHERE ( ".$where." )";
		dbg($query,"query");
		$result = mysql_query($query) or fatal("Query failed : " . mysql_error(),"DB");
		while ($line = mysql_fetch_array($result, MYSQL_ASSOC)) {
			foreach ($line as $fn=>$col_value) {
				$out .= "$fn: $col_value<br>";
			}
		}
	} else {
		$out .= "<p>".$sometext."<b> ".$table."</b> $othertext</p>";
		$query = $optext.$table.$where;
		$result = mysql_query($query) or fatal("Query failed : " . mysql_error(),"DB");
		$out .= "<p><b>Result:</b>".mysql_affected_rows($link)." rows affected.</p>";
	}
	return $out;
}
function delete($link,$args)
{
	$out = "";
	$where = urldecode($args[where]);
	$table = $args['table'];
	if(!$where || !$table)
		fatal("no table or where given","Internal");
	$out .= quicksql($link,"DELETE FROM ",$table," WHERE ( ".$where." )","Deleting from",
		"where <b>".$where."</b>...");
	parse_str($args['returnurl'],$retargs);
	return $out."<hr>".search($link,$retargs);
}
function insert($link,$args)
{
	$out = "";
	$valuesarr = "";
	foreach($args[value] as $v) {
		$valuesarr[] = "'".trim(addslashes(urldecode($v)))."'";
	}
	$values = implode(",",$valuesarr);
	$table = $args['table'];
	if(!$values || !$table)
		fatal("no table or where given","Internal");
	$out .= quicksql($link,"INSERT INTO ",$table," VALUES ( ".$values." )","Inserting into",
		"values <b>".$values."</b>...");
	return $out.search($link,$args);
}
function print_head($section) {
	echo "<!DOCTYPE HTML PUBLIC '-//W3C//DTD HTML 4.0//EN' " ."--'http://www.w3.org/TR/REC-html40/strict.dtd'--> \n"
	."<html>\n"
	."<head>\n"
	."<title>gps db admin tool</title>\n"
	."<style type='text/css'><!--\n"
	."body {\n"
	."  text-align: center;\n"
	."}\n"
	."h2 {\n"
	."  text-align: center;\n"
	."  font-family: arial,helvetica,sans-serif;\n"
	."}\n"
	."td {\n"
	."  text-align: left;\n"
	."  vertical-align: top;\n"
	."}\n"
	."th {\n"
	."  text-align: center;\n"
	."  font-family: arial,helvetica,sans-serif;\n"
	."}\n"
	.".hint {\n"
	."  text-align: center;\n"
	."  font-family: monotype;\n"
	."  font-size: smaller;\n"
	."}\n"
	.".sm {\n"
	."  font-size: smaller;\n"
	."}\n"
	."--></style>\n"
	."</head>\n"
	."<body>\n";
};

/** main **/
/** The $cfg=readConfigFile(); below 
    can be changed to a static array 
    in case php doesnt have access permissions 
    to the gps config file
    $cfg = array("
      "dbtype" => "mysql",
      "db_host" => "localhost",
      "db_username" => "greylist",
      "db_password" => "secret",
      "db_dbname" => "greylist" );
**/
if(isset($_REQUEST[mode]))
	$mode = (string)$_REQUEST[mode];
else
	$mode = "show_tables";
print_head($mode);
$cfg = readConfigFile(); /** <- change this ! **/
if(VERBOSE)
	dbg($cfg);
if($cfg[dbtype] != 'mysql')
	fatal("Database type ".$cfg[dbtype]." not supported.","DB");

if($mode != "show_tables") {
	if($_REQUEST[title])
	echo "<h2>".$_REQUEST[title]
	.($_REQUEST[table]?" <span style='font-size: smaller;'>(".$_REQUEST[table].")</span>":"")
	."</h2>";
	echo "<a href='./'>Home</a>\n";
} else {
	echo "<h2>gps database administration tool</h2>";
}
echo "<hr>\n";
$link = mysql_connect($cfg[db_host], $cfg[db_username], $cfg[db_password])
   or fatal("Could not connect : " . mysql_error(),"DB");
pr_dbstatus("Connected successfully",$cfg);
echo "<hr>\n";
mysql_select_db($cfg[db_dbname]) or fatal("Could not select database: ".$cfg[db_dbname],"DB");
	
	
echo "<table align='center'><tr><td>\n";
if(function_exists($mode))
	echo call_user_func($mode,$link,$_REQUEST);
else
	dbg("Function ".$mode." not implemented yet","Internal");
echo "</td></tr></table>\n";
/* Closing connection */
mysql_close($link);

echo "<hr>\n";
echo "<p style='font-size:smaller; color: grey; text-align:center;'>gps database administration tool<br>";
echo "(C)2004 Michael Moritz mimo/at/restoel.net<br>";
echo "<a href='http://mimo.gn.apc.org/gps/'>gps Homepage</a>";
echo "</body>\n</html>";
?> 
